using System.Data;
using Microsoft.Extensions.Configuration;
using MySql.Data.MySqlClient;

namespace Website.Data
{
	public class MySQLDatabaseProvider:IDatabaseProvider
	{
		private readonly string _connectionString;

		public MySQLDatabaseProvider(IConfiguration config) => _connectionString = config.GetConnectionString("database");

		public MySQLDatabaseProvider(string connectionString) => _connectionString = connectionString;

		public IDbConnection NewConnection() => new MySqlConnection(_connectionString);
	}
}